Solvedtype graphql Integration with Prisma

Originally posted by @ntziolis in #77 (comment)

There are various reasons why we feel when solving this issue a lot of other goodness would come from it:

  • prisma has a VERY poor data model migration story, in particular:
    • no versioning of schema during dev time
    • deployment of the same schema causes deployment errors in many cases breaking CI pipelines
    • no support for up/down migrations
  • using partial or changed types in public schema only possible via copy&paste
    • using the same types in your public schema minus a few fields requires copy&pasting the type (and related types) and manually removing the fields in question
    • causes errors when our devs update prisma data model but forget todo the same on the public side (lets be honest this happens a lot)

In order to clean this up and follow DRY here is how we wanted to use type-graphql

  • type-graphql becomes our way of defining both public & prisma schema
  • at the same time be able to generate type safe resolvers for the public schema
  • and use the additional features to standardize on DI etc most of which is handled manually / project by project today with different libs

I understand this might have been the initial intention of type-graphql but I can tell you after the 10th+ graphql project: The need for a framework that is the beginning and end where types originate is VERY high especially when using a graphql datasource underneath (we have tried various beyond prisma).

18 Answers

βœ”οΈAccepted Answer

Hi @19majkel94! We're still very interested in supporting you with a seamless Prisma integration. Given the very nature of developers, there will always be some opinionated preferences and we're trying to work with framework authors like you to fit Prisma as well as possible into your API design and ecosystem.

We're currently working towards Prisma 2 which will also include the prisma-sdk which allows you to programmatically use all Prisma features (such as DB introspection, client generation, migration system, query engine, ...) individually. Could you even decide to "hide" to the developer that Prisma is being used and come up with your own UX flows that use Prisma under the hood.

Here's an idea how the API could look like:

@ObjectType
@Prisma({
  model: 'Product',
  pick: ['id', 'name', 'type', 'brand', 'variants'],
})
export class Product {

  @Field
  options(args?: { showAll?: boolean }): Promise<Option[]> {
    return this.ctx.prisma.options()
  }

  @Mutation({ name: "setProductPrice" })
  setPrice(price: number) {
    // ...
  }

}

Other Answers:

I have a working basic integration on a private repo πŸ’ͺ Waiting for feedback from Prisma team and for some changes in the Prisma generator API to make it easier work on non-UNIX OSes πŸ˜‰

The preview of the integration is now publicly available πŸŽ‰

https://twitter.com/MichalLytek/status/1199708285622005761

Closing this issue in favor of #476 to indicate that only the new Prisma Framework (Prisma 2) will be supported πŸ”’

@schickling

We're currently working towards Prisma 2 which will also include the prisma-sdk which allows you to programmatically use all Prisma features

That's great! SDK with programmatical way to register Prisma types and generate client, etc. would be great, as printing a prisma.datamodel file with directives is not possible with graphql-js.

Wrapping/hiding this under the decorator-based API is the simplest thing to do πŸ˜‰ Can't wait to try the alpha/beta of the SDK!

@schickling

We're currently working towards Prisma 2 which will also include the prisma-sdk which allows you to programmatically use all Prisma features

Great news indeed.
Any information available atm on this? Like roadmap, possible to alpha/beta test, documentation and specs?

I am currently prototyping an extendable framework and I want prisma to be a prime citizen. Also considering type-graph and maybe nexus as plugin schema definition providers.
But one feature that is mandatory is to define a single schema composed of modules and use it to resolve both database and business logic schemas. And with that update Prisma with latest schema changes on the fly.

Would really appreciate at least a generic idea of when would this be possible to plan my roadmap accordingly.

Thanks.

Related Issues:

101
type graphql Getting "Schema must contain uniquely named types but contains multiple types named" for a single type
This was a hard one to track down with an annoying fix (Nest specific not the fault of type-graphql)...
47
type graphql Cannot determine GraphQL input type for
For future readers This may have been due to using an @ObjectType() CompanyData as an @InputType() i...
28
type graphql Integration with Prisma
Hi @19majkel94! We're still very interested in supporting you with a seamless Prisma integration Giv...
5
type graphql Error when using GraphQLJSON
@darkmantle Setting: Means you should use default import: The latest version (0.15.0) seems to have ...
227
neovim build fails with OSX Mojave
Starting with Mojave the headers are no longer installed under /usr/include/ by default -- look unde...
124
graphql engine relay support
Hi @srghma @toxsick relay makes assumptions about the GraphQL server as outlined here We haven't mad...
122
amplify cli Many-To-Many
You can implement many to many yourself using two 1-M @connections and a joining @model ...
111
zeal Content rendering error in MDN (HTML, JS, CSS) docsets
I find it can fix temporary by remove the CSS.docset\Contents\Resources\Documents\developer.mozilla....
98
axios module How to set query params and message body?
No I don't mean the baseURL but the url path As an example let's say I have the following call: Axio...
96
strapi πŸ‘‰ Question: What are the main pain points you have using Strapi? (Episode 3)
Pain point Issue: No TypeScript support Context: I know it has been mentioned as something the team ...
96
fastapi WARNING: Unsupported upgrade request.
This error is not part of the FastAPI codebase When attempting to run this (using UviCorn) it starts...
90
neovim Build failed with Homebrew on both macOS 11.4 and 12.0.1
This should be fixed in Homebrew for now Neovim version (nvim -v) Upgrading neovim HEAD-487286b -> H...
83
amplify cli aws-exports.js is not generated
Even after the third read I find it utterly confusing and I have usability issues too ...
76
web3.js sendSignedTransaction() error: invalid sender
@paulrberg If you want to use the version: 2.0.0 you should add extra parameter chain like this ...
69
web3.js The method personal_unlockAccount does not exist/is not available
@vijayr2410 Well Looks like it's just require to specify following parameters to resolve this issue ...
64
fastapi [QUESTION] How to bridge Pydantic models with SQLAlchemy?
I just finished integrating Pydantic ORM mode into FastAPI it is released as version 0.30.0 πŸŽ‰ The n...
61
web3.js Handle web socket disconnects
You can listen to events from the WebSocketProvider to detect disconnects. Im making an app that mon...
61
strapi New project fails to connect to database
I had the same issue with 3.0.0-alpha.10 I ran strapi new project-name then when it prompts to enter...
59
ponzu no go files in /home/user/go/src/github.com/ponzu-cms/ponzu
try running go get -u github.com/ponzu-cms/ponzu/.. via copy / paste that exact command. ...
56
amplify cli @auth public/private IAM roles and other Providers
ok my bad was actually quite easy just do : and add a auth provider in my case was IAM ...
55
neovim Update tree-sitter to v0.19.0
Workaround for homebrew users: Uninstall tree-sitter@0.19.1 ignoring neovim dependency Extract the f...
52
fastapi [QUESTION] How to send 204 response?
Instead of returning None and instead of injecting the response just return a newly created response...
48
strapi Refresh JWT route
This is quite important for my app So I implement it by extending plugin (for temporary use) Here's ...
44
amplify cli jest-haste-map: Haste module naming collision: -> namefunction <-
For React Native 0.6x configure the blacklist in metro.config.js instead of rn-cli.config.js as per ...
44
chi chi@v1.5.x mod issues
I do not want to release /v5 and see it on the import path I'm not sure why you are considering /v5 ...
43
Jackett The method or operation is not implemented. (all indexers!)
Working on Synology after manual update Note that this worked for my DS415+ that is using the Mono v...
42
fastapi OpenAPI UI not working properly when using automatic swagger-ui CDN (swagger-ui-3.30.1)
Thanks for reporting it and for all the discussion here everyone! πŸš€ β˜• Indeed it's a bug in Swagger ...
40
web3.js Transferring ERC20 tokens from account using web3 over Ropsten
Single-address allocation of MineFIL Token (MFIL) code which was written and tested using web3 versi...
39
L5 Swagger oauth2 + passport = Bearer <token>
Sharing my solution in case it might help This is I how made it to work with Passport using password...
38
neovim homebrew build fails to start (segfault in libtermkey 0.21)
EDITOR=/usr/bin/vim brew edit libtermkey edit the URL to libtermkey-0.20.tar.gz and the hash to 6c0d...
37
web3.js Error: Can't resolve 'crypto'
Ah yes!! this solution with the patch worked: https://gist.github.com/niespodd/1fa82da6f8c901d1c33d2...
36
web3.js Truffle and Ganache providers, Metamask Provider Engine no longer accepted as valid by web3
For those who might not know me I'm part of the Truffle team and @davidmurdoch and I oversee the dev...
34
core Non anemic doctrine models are not supported
Regarding the general design of API Platform and how it fits with command buses and/or event sourcin...
34
neovim Feature: optional floating window borders
This works for me Not sure why but it does. #6619 Added floating windows but no way to create a bord...
34
axios module How to import module to external file
@lukasborawski I think the following solution is far more elegant So let's say that I'm using axios ...
34
fastapi [QUESTION] Is this the correct way to save an uploaded file ?
@classywhetten FastAPI has almost no custom logic related to UploadFile -- most of it is coming from...
34
fastapi [QUESTION] Storing object instances in the app context
@ebarlas you're 100% right Description In Flask ...
33
amplify cli runtime parameter of nodejs8.10 is no longer supported
@asyschikov where can you find the build settings for amplify CLI that you are refering to ? For tho...
32
graphql engine Support for Mac M1
Hey folks Sorry for the radio silence on the thread from the Hasura team Add Hasura Support for Mac ...
31
api platform normalization context don't work on symfony v5.1.99
Try to run ./bin/console cache:clear API Platform version(s) affected: x.y.z Description when i make...
30
amplify cli Connect a cognito user with an AppSync type
Any updates on this? Having to manually write a Lambda triggered by Cognito events to create an AppS...
30
graphql engine Handling multiple roles on the graphql client (possibly in the same query)
@shahidhk .. my understanding of the current JWT role workflow is: The token is decoded ...
30
fastapi [QUESTION] aiohttp integration best practice
That is one way if you want create a new session for every request You can also use a singleton appr...
28
amplify cli npm install -g @aws-amplify/cli error
sudo npm install -g --unsafe-perm --verbose @aws-amplify/cli worked for me. npm install -g @aws-ampl...
27
web3.js Transaction was not mined within 50 blocks, please make sure your transaction was properly send. Be aware that it might still be mined!
I think I found the error When I call a contract function and await the send startWatching is invoke...
27
Jackett yggtorrent - new address
the YGGTorrent website has changed their domain to .ws And you should be able to get the Jackett YGG...
26
amplify cli Amplify push fails with error creating directory
I retried the amplify push command and changed the two paths that default to / to ./ and the command...
26
amplify cli Amplify API push fails
I also had trouble with amplify push In my case APIKeyExpirationEpoch: -1 did not help ...
26
loopback next Feature parity with LoopBack 3.x (and the lack of it)
Some of the big hitters here that are blocking us from migrating from LB3 to LB4 would be: Polymorph...
26
slate Question: Initialising Error - Bundle
Yay I figured it out You need to install Ruby Full To do so open your Terminal and type - Follow the...